## WDDM Queues

The Windows Display Driver Model (WDDM) architecture uses queues to send work packets from the CPU to the GPU. Each D3D device in each process is associated with 1 or more contexts. Graphics, compute and copy commands that the profiled application uses are associated with a context, batched in a command buffer and pushed into the relevant queue that is associated with that context.

Nsight Systems can capture the state of these queues during the trace session.

A command buffer in a WDDM queues may have one the following types:

- Render
- Deferred
- System
- MMIOFlip
- Wait
- Signal
- Device
- Software

It may also be marked as a Present buffer, indicating that the application has finished rendering and requests to display the source surface.

See the Microsoft documentation for the WDDM architecture and the DXGKETWQUEUEPACKET_TYPE enumeration.

Copyright (c) 2012-2020, NVIDIA Corporation. All rights reserved.